var http = require('http');
var ipfs = new (require('ipfs'));
var fs = require('fs');
var rpcRequest = require('request-promise');
var resultTmp = new Object();
const a = require('./readCfgJson.js').readCfgJson();
var port = a.sdchaind_upload_js_port;
async function RPCRequestReadCfg(){
	var opt = {	//get ipfs_fee_info post url
		method:'POST',
	       	uri: a.sdchaind_url+":"+ a.sdchaind_rpc_port,
       		body:{
		       "method":'ipfs_fee_info'
		},
		json: true,
		headers:{
		      'content-type':'application/json'
      		}
	}
	console.log("tttttttttttttttt"+opt.uri);
	var rpcResultTmp = await rpcRequest(opt);
	return rpcResultTmp;
}
async function getIPFSFeeInfo(){
	var cfg = require("./ini-file-loader").load(a.sdchaind_cfg_location)[a.sdchaind_cfg_ipfs];
	var resultTmp = {}
	if(!cfg){	//get ipfs_fee_info from sdchaind'd RPC Interface
		resultTmp =  await RPCRequestReadCfg();
		resultTmp.charge_account = resultTmp.result.accountID;
		resultTmp.storage_fee = resultTmp.result.downloadFee;
		resultTmp.download_fee = resultTmp.result.storageFee;
	}else{		//get ipfs_fee_info from local sdchaind's SDChain-core.cfg .
		resultTmp.charge_account = cfg[a.sdchaind_cfg_accountID];
		resultTmp.storage_fee = cfg[a.sdchaind_cfg_storageFee];
		resultTmp.download_fee = cfg[a.sdchaind_cfg_downloadFee];
	}
	return resultTmp;
}
http.createServer(function (req, res) {
		console.log(req.headers);
		console.log(req.complete);

		var body = '';
		req.on('data', function(data) {
				body += data;
				});
		req.on('end', function() {
				console.log(req.complete);
				console.log(body);
				var result = parseMultiParts(body, req.headers);
				if (result) {
				console.log(result.files);
				processFiles(result.files, function (err, files) {
						if (err) {
						res.writeHead(404, {'Content-Type': 'text/html'});
						res.write('Upload file failed!');
						res.end();
						return;
						}
						getIPFSFeeInfo().then( resultTmp => { 
								result.charge_account =	resultTmp.charge_account;
								result.storage_fee = resultTmp.storage_fee;
								result.download_fee = resultTmp.download_fee;

								console.log(result);
								console.log(JSON.stringify(result));

								//res.writeHead(200, {'Content-Type': 'text/html'});
								//res.write('You get "' + req.url + '" sucessfully!')
								res.writeHead(200, {'Content-Type': 'application/json;charset=utf-8'});
								res.write(JSON.stringify(result));
								res.end();
								});
				});
				} else {
					res.writeHead(400, {'Content-Type': 'text/html'});
					res.write('Invalid request!');
					res.end();
				}
		});
}).listen(port, function (err) {
	if (err) {
	throw err;
	}

	console.log(`sdchaind starts listening at ${port}!`);
	});


function parseMultiParts(body, headers) {
	var boundary = 'multipart/form-data; boundary=';
	var content_type = headers['content-type'];
	if (content_type) {
		pos = content_type.indexOf(boundary);
		if (pos != -1) {
			boundary = content_type.substr(pos + boundary.length);
		} else {
			boundary = null;
		}
		console.log(content_type, pos, boundary);
	} else {
		boundary = null;
	}

	if (!boundary) return null;

	body = body.split('\r\n');
	var result = {};
	var files = {};
	for (let i = 0; i < body.length - 4; i += 4) {
		pos = body[i+1].indexOf('name=');
		if (pos == -1) {
			i -= 3;
			continue;
		}
		name = body[i+1].substring(pos+6);
		name = name.substring(0, name.length-1).split('.');
		if (name.length != 2) {
			result[name[0]] = body[i+3];
			continue;
		}

		var file = files[name[0]];
		if (!file) {
			file = {};
			files[name[0]] = file;
		}
		file[name[1]] = body[i+3];
	}

	var n = 0;
	var a = [];
	for (let f in files) {
		a[n] = files[f];
		n += 1;
	}

	result.files = a;
	return result;
}
// add file to ipfs
async function processFiles(files, callback) {
	var err = null;
	var prefix = '';
	try {
		for (let i in files) {
			let path = prefix + files[i].path;
			let result = await ipfs.addFromFs(path, {onlyHash : true});
			console.log(result);

			let pos = path.lastIndexOf('/');
			let new_path = result[0].hash;
			if (pos != -1) {
				new_path = path.substr(0, pos+1) + new_path;
			}

			try {
				await fs.promises.stat(new_path);
			} catch (e) {
				err = e
			}

			if (!err) {
				throw `File '${new_path}' has existed!`;
			}

			err = null
				await fs.promises.rename(path, new_path);
			delete files[i].path;
			files[i].id = result[0].hash;
		}
	} catch (e) {
		err = e;
		console.log(e);
	}

	callback(err, files);
}
